#ifdef WIN32
#pragma comment(lib, "c:\\TopfieldDisk\\DataFiles\\SDK\\TAP_SDK_DLL")
#include "TAP_Emulations.h"
#endif

#include "tap.h"
#include "Config.h"
#include "skin.h"

bool isTF5800PVRt();

#define OPTIONS_FILENAME "SuperPip.ini"
#define DATA_BUFFER_SIZE_ini 1024

static char  buffer[256];
static char  *dataBuffer_ini;
static int   dataBufferPtr_ini;

extern bool debug;

int compareStrings (const void *s1, const void *s2)
{
	char *string_1 = *(char **) s1;
	char *string_2 = *(char **) s2;

	return strcmp(string_1, string_2);
}

bool isSkin(char *name)
{
    strcpy(buffer, name);
    strlwr(buffer);

	if (strlen(buffer) < 5) return FALSE;

    if (strcmp(buffer + strlen(buffer) - 4, ".mcf" ) == 0)
        return TRUE;

    return FALSE;
}

bool isFav(char *name)
{
    strcpy(buffer, name);
    strlwr(buffer);

	if (strlen(buffer) < 5) return FALSE;

    if (strcmp(buffer + strlen(buffer) - 4, ".mcl" ) == 0)
        return TRUE;

    return FALSE;
}

void ChangeDirRoot()
{
	TYPE_File	fp;
	int		index;

	index = 0;
	TAP_Hdd_FindFirst(&fp);

    //	loop until root found, allow maximum of 20 levels
	while ((strcmp(fp.name, "__ROOT__") != 0) && (index++ < 20))
	{
		TAP_Hdd_ChangeDir("..");
		TAP_Hdd_FindFirst(&fp);
	}
}

void ChangeDirProgramFiles()
{
	ChangeDirRoot();
	TAP_Hdd_ChangeDir("ProgramFiles");
}

void ChangeDirSettings()
{
	ChangeDirRoot();
	TAP_Hdd_ChangeDir("ProgramFiles");
	if (!TAP_Hdd_Exist("Settings"))
		TAP_Hdd_Create("Settings", ATTR_FOLDER);
	TAP_Hdd_ChangeDir("Settings");
}

void ChangeDirSkins()
{
	ChangeDirSettings();
	if (!TAP_Hdd_Exist("Skins"))
		TAP_Hdd_Create("Skins", ATTR_FOLDER);
	TAP_Hdd_ChangeDir("Skins");
}

bool ChangeDirFavs()
{
	ChangeDirSettings();
	
	/*if (!TAP_Hdd_Exist("MyStuff"))
		TAP_Hdd_Create("MyStuff", ATTR_FOLDER);
	TAP_Hdd_ChangeDir("MyStuff");
	if (!TAP_Hdd_Exist("FavLists"))
		TAP_Hdd_Create("FavLists", ATTR_FOLDER);
	TAP_Hdd_ChangeDir("FavLists");*/

	if (TAP_Hdd_Exist("MyStuff")) {
		TAP_Hdd_ChangeDir("MyStuff");
		if (TAP_Hdd_Exist("FavLists"))
			TAP_Hdd_ChangeDir("FavLists");

		return TRUE;
	}

	return FALSE;
}

void WriteIniFile()
{
	TYPE_File	*writeFile;

	if ( TAP_Hdd_Exist( OPTIONS_FILENAME ) ) TAP_Hdd_Delete( OPTIONS_FILENAME );	// Just delete any old copies

	TAP_Hdd_Create( OPTIONS_FILENAME, ATTR_PROGRAM );						// Create the file

	writeFile = TAP_Hdd_Fopen( OPTIONS_FILENAME );
	if ( writeFile == NULL ) return; 										// Check we can open it

	TAP_Hdd_Fwrite( dataBuffer_ini, DATA_BUFFER_SIZE_ini, 1, writeFile );	// dump the whole buffer in one hit

	TAP_Hdd_Fclose( writeFile );
}

void WriteStrToIniBuf( char *str )											// add str to current end of buffer
{																			// and move end out
	int count, i;

    count = (int) strlen(str);
	
	for ( i=0; i<count; i++)
	{
		dataBuffer_ini[dataBufferPtr_ini+i] = str[i];							// copy accross 1 char at a time
	}
	dataBufferPtr_ini += i;
}

void SaveConfigurationToFile( void )
{
	dataBuffer_ini = TAP_MemAlloc( DATA_BUFFER_SIZE_ini );				// Buffer the write data to memory before writing all in one hit
	memset( dataBuffer_ini, '\0', DATA_BUFFER_SIZE_ini );				// set the whole buffer to the string termination character (null)
	dataBufferPtr_ini = 0;

	//TAP_SPrint(buffer4, "%s\r\n", default_slideshow_directory);
	//WriteStrToIniBuf( buffer );
	
	TAP_SPrint(buffer, "%d\r\n", version_number);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[0].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", startup_main_x);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", startup_main_y);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", startup_main_w);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", startup_main_h);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", startup_sub_x);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", startup_sub_y);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", startup_sub_w);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", startup_sub_h);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", masterpiece_mode);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", recall_snap);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%s\r\n", skin_file_name);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[1].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[2].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[3].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[4].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[5].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[6].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[7].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[8].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[9].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[10].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[11].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[12].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[13].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[14].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[15].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[16].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[17].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", config_keys[18].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", display_icons);
	WriteStrToIniBuf( buffer );
	
	TAP_SPrint(buffer, "%s\r\n", fav_file_name);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", firmware_hacks_enabled);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", topfield_model);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[0].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[1].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[2].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[3].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[4].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[5].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[6].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[7].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[8].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[9].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[10].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[11].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[12].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[13].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[14].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[15].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[16].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[17].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[18].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", normal_keys[19].key_value);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", reverse_pip_key);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", pip_key);
	WriteStrToIniBuf( buffer );

	TAP_SPrint(buffer, "%d\r\n", info_delay);
	WriteStrToIniBuf( buffer );

	WriteIniFile();										// write all the data in one pass
	TAP_MemFree(dataBuffer_ini);										// must return the memory back to the heap
}


//------------------------------------------------------------------
//
char *ReadIniField( void )
{
	int i;
	char readChar;
	char *oldPtr;

	oldPtr = (char *) dataBuffer_ini + dataBufferPtr_ini;

	i=0;
	while ( dataBufferPtr_ini < DATA_BUFFER_SIZE_ini )					// Bounds check
	{
		readChar = dataBuffer_ini[dataBufferPtr_ini];					// read the file one character at a time

		if ( readChar == '\t' ) break;									// looking for TAB delimiter,
		if ( readChar == '\n' ) break;									// or end of line.
		if ( readChar == '\r' )
		{																// Carriage return is followed by new line -> discard them both.
			dataBuffer_ini[dataBufferPtr_ini] = '\0';
			dataBufferPtr_ini++;
			break;
		}
		if ( readChar == '\0' ) break;									// Null terminator signifies end of file

		dataBufferPtr_ini++;
	}

	dataBuffer_ini[dataBufferPtr_ini] = '\0';							// add a terminator to the string
	dataBufferPtr_ini++;
	return oldPtr;														// return a pointer to the start of the current field
}

dword ReadIniDecimal( void )
{
	dword	tmp;
	int i;
	
	strcpy( buffer, ReadIniField() );										// Read the field
	if (debug) TAP_Print("Read in %s\r\n", buffer);
	tmp = 0;
	i = 0;

	while ( buffer[i] != '\0' )
	{
	    tmp = (tmp * 10) + (buffer[i] - '0');
		i++;
	}

	return tmp;
}


void SetConfigurationVariables( void )
{
	version_number = ReadIniDecimal();
	if (version_number < 1 || version_number > 1024) {
		config_keys[0].key_value = version_number;
		version_number = 0;
	}
	else {
		config_keys[0].key_value	= ReadIniDecimal();
	}
	startup_main_x				= ReadIniDecimal();
	startup_main_y				= ReadIniDecimal();
	startup_main_w				= ReadIniDecimal();
	startup_main_h				= ReadIniDecimal();
	startup_sub_x				= ReadIniDecimal();
	startup_sub_y				= ReadIniDecimal();
	startup_sub_w				= ReadIniDecimal();
	startup_sub_h				= ReadIniDecimal();
	masterpiece_mode			= ReadIniDecimal();
	recall_snap					= ReadIniDecimal();
	strcpy(skin_file_name,		ReadIniField());
	config_keys[1].key_value	= ReadIniDecimal();
	config_keys[2].key_value	= ReadIniDecimal();
	config_keys[3].key_value	= ReadIniDecimal();
	config_keys[4].key_value	= ReadIniDecimal();
	config_keys[5].key_value	= ReadIniDecimal();
	config_keys[6].key_value	= ReadIniDecimal();
	config_keys[7].key_value	= ReadIniDecimal();
	config_keys[8].key_value	= ReadIniDecimal();
	config_keys[9].key_value	= ReadIniDecimal();
	config_keys[10].key_value	= ReadIniDecimal();
	config_keys[11].key_value	= ReadIniDecimal();
	config_keys[12].key_value	= ReadIniDecimal();
	config_keys[13].key_value	= ReadIniDecimal();
	config_keys[14].key_value	= ReadIniDecimal();
	config_keys[15].key_value	= ReadIniDecimal();
	config_keys[16].key_value	= ReadIniDecimal();
	config_keys[17].key_value	= ReadIniDecimal();
	config_keys[18].key_value	= ReadIniDecimal();
	display_icons				= ReadIniDecimal();
	strcpy(fav_file_name,		ReadIniField());
	firmware_hacks_enabled		= ReadIniDecimal();
	topfield_model				= ReadIniDecimal();
	normal_keys[0].key_value	= ReadIniDecimal();
	normal_keys[1].key_value	= ReadIniDecimal();
	normal_keys[2].key_value	= ReadIniDecimal();
	normal_keys[3].key_value	= ReadIniDecimal();
	normal_keys[4].key_value	= ReadIniDecimal();
	normal_keys[5].key_value	= ReadIniDecimal();
	normal_keys[6].key_value	= ReadIniDecimal();
	normal_keys[7].key_value	= ReadIniDecimal();
	normal_keys[8].key_value	= ReadIniDecimal();
	normal_keys[9].key_value	= ReadIniDecimal();
	normal_keys[10].key_value	= ReadIniDecimal();
	normal_keys[11].key_value	= ReadIniDecimal();
	normal_keys[12].key_value	= ReadIniDecimal();
	normal_keys[13].key_value	= ReadIniDecimal();
	normal_keys[14].key_value	= ReadIniDecimal();
	normal_keys[15].key_value	= ReadIniDecimal();
	normal_keys[16].key_value	= ReadIniDecimal();
	normal_keys[17].key_value	= ReadIniDecimal();
	normal_keys[18].key_value	= ReadIniDecimal();
	normal_keys[19].key_value	= ReadIniDecimal();
	reverse_pip_key				= ReadIniDecimal();
	pip_key						= ReadIniDecimal();
	info_delay					= ReadIniDecimal();
}

bool ReadConfigurationFile(void)
{
	TYPE_File *readFile;
	dword fileLength;

	ChangeDirSettings();

	if ( ! TAP_Hdd_Exist( OPTIONS_FILENAME ) ) return FALSE;			// check the photo file exits in the current directory
	
	readFile = TAP_Hdd_Fopen( OPTIONS_FILENAME );
	if ( readFile == NULL ) return FALSE;								// and we can open it ok

	dataBuffer_ini = TAP_MemAlloc( DATA_BUFFER_SIZE_ini );				// Read the data in one hit (quicker), then process from RAM
	memset( dataBuffer_ini, '\0', DATA_BUFFER_SIZE_ini );					// set the whole buffer to the string termination character (null)
	dataBufferPtr_ini = 0;

	fileLength = TAP_Hdd_Flen( readFile );								// how big is the file
	if ( fileLength > DATA_BUFFER_SIZE_ini  ) fileLength = DATA_BUFFER_SIZE_ini;	// ensure we don't overflow the buffer

	TAP_Hdd_Fread( dataBuffer_ini, fileLength, 1, readFile );			
	TAP_Hdd_Fclose( readFile );

	SetConfigurationVariables();

	TAP_MemFree( dataBuffer_ini );										// must return the memory back to the heap

	return TRUE;
}

void loadSkins()
{
	TYPE_File file;
	dword i;

	skin_count = 0;
	i = TAP_Hdd_FindFirst(&file);
    while(i-- && skin_count < 128) {
        if (isSkin(file.name)) {
			memset (&skins[skin_count], 0, sizeof(skins[skin_count]));
			skins[skin_count] = TAP_MemAlloc(100 * sizeof(char));
			strcpy(skins[skin_count], file.name);
			skin_count++;
        }

        if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
            break;
    }
	qsort(skins, skin_count, sizeof(skins[0]), compareStrings);

	// find the index of the current skin
	for (i = 0; i < skin_count; i++) {
		if (strcmp(skins[i], skin_file_name) == 0)
            current_skin = i;
	}

	if (debug) TAP_Print("%d skins loaded\r\n", skin_count);
}

void loadFavourites()
{
	TYPE_File file;
	dword i;

	fav_count = 0;

	i = TAP_Hdd_FindFirst(&file);
    while(i-- && fav_count < 32) {
        if (isFav(file.name)) {
			memset (&favs[fav_count], 0, sizeof(favs[fav_count]));
			favs[fav_count] = TAP_MemAlloc(100 * sizeof(char));
			strcpy(favs[fav_count], file.name);
			fav_count++;
        }

        if (i == 0 || TAP_Hdd_FindNext(&file) == 0)
            break;
    }
	qsort(favs, fav_count, sizeof(favs[0]), compareStrings);

	// find the index of the current skin
	current_fav = -1;
	for (i = 0; i < fav_count; i++) {
		if (strcmp(favs[i], fav_file_name) == 0)
            current_fav = i;
	}

	if (debug) TAP_Print("%d favs loaded\r\n", fav_count);
}

bool readFavouritesFile(char *fav_name)
{
	TYPE_File *fav_file;
	dword file_length;

	if (!TAP_Hdd_Exist(fav_name)) return FALSE;		
	
	fav_file = TAP_Hdd_Fopen(fav_name);
	if (fav_file == NULL) return FALSE;					

	dataBuffer_ini = TAP_MemAlloc(512);
	memset(dataBuffer_ini, '\0', 512);
	dataBufferPtr_ini = 0;

	file_length = TAP_Hdd_Flen(fav_file);				
	if ((file_length > 0)&& (file_length % 512) == 0)
		file_length = file_length + 512;

	TAP_Hdd_Fread(dataBuffer_ini, file_length, 1, fav_file);

	TAP_Hdd_Fclose(fav_file);
									
	return TRUE;
}

void loadFavouriteChannel()
{
	dword favourite = ReadIniDecimal();
	if (favourite > 0) {
		favourite_channels[number_of_favourites] = favourite;
		number_of_favourites++;
	}
}

void loadFavouriteChannels()
{
	number_of_favourites = 0;

	if (readFavouritesFile(fav_file_name)) {
		while (dataBuffer_ini[dataBufferPtr_ini+1] != '\0')
			loadFavouriteChannel();

		TAP_MemFree(dataBuffer_ini);
	}
}

void LoadConfiguration( void )
{
	if (debug) TAP_Print("Load config\r\n");

	if ((!ReadConfigurationFile()))  // If file is invalid, recreate a new one.
	{
		config_keys[0].key_value	= RKEY_TvSat;
		startup_main_x				= 10;
		startup_main_y				= 576/4;
		startup_main_w				= (720-30)/2;
		startup_main_h				= (576)/2;
		startup_sub_x				= 720/2+5;
		startup_sub_y				= 576/4;
		startup_sub_w				= (720-30)/2;
		startup_sub_h				= (576)/2;
		masterpiece_mode			= FALSE;
		recall_snap					= SPLIT_SCREEN;
		strcpy(skin_file_name,		"SuperPip.mcf");
		config_keys[1].key_value	= RKEY_Recall;
		config_keys[2].key_value	= RKEY_Pause;
		config_keys[3].key_value	= RKEY_Record;
		config_keys[4].key_value	= RKEY_ChUp;
		config_keys[5].key_value	= RKEY_ChDown;
		config_keys[6].key_value	= RKEY_VolDown;
		config_keys[7].key_value	= RKEY_VolUp;
		config_keys[8].key_value	= RKEY_Rewind;
		config_keys[9].key_value	= RKEY_Forward;
		config_keys[10].key_value	= RKEY_2;
		config_keys[11].key_value	= RKEY_8;
		config_keys[12].key_value	= RKEY_4;
		config_keys[13].key_value	= RKEY_6;
		config_keys[14].key_value	= RKEY_1;
		config_keys[15].key_value	= RKEY_3;
		config_keys[16].key_value	= RKEY_9;
		config_keys[17].key_value	= RKEY_7;
		config_keys[18].key_value	= RKEY_5;
		display_icons				= TRUE;
		strcpy(fav_file_name,		"");
		firmware_hacks_enabled		= FALSE;
		topfield_model				= TF5800;
		normal_keys[0].key_value	= RKEY_ChUp;
		normal_keys[1].key_value	= RKEY_ChDown;
		normal_keys[2].key_value	= RKEY_VolUp;
		normal_keys[3].key_value	= RKEY_VolDown;
		normal_keys[4].key_value	= RKEY_None;
		normal_keys[5].key_value	= RKEY_None;
		normal_keys[6].key_value	= RKEY_None;
		normal_keys[7].key_value	= RKEY_None;
		normal_keys[8].key_value	= RKEY_None;
		normal_keys[9].key_value	= RKEY_None;
		normal_keys[10].key_value	= RKEY_None;
		normal_keys[11].key_value	= RKEY_None;
		normal_keys[12].key_value	= RKEY_None;
		normal_keys[13].key_value	= RKEY_None;
		normal_keys[14].key_value	= RKEY_None;
		normal_keys[15].key_value	= RKEY_None;
		normal_keys[16].key_value	= RKEY_None;
		normal_keys[17].key_value	= RKEY_None;
		normal_keys[18].key_value	= RKEY_None;
		normal_keys[19].key_value	= RKEY_None;
		reverse_pip_key				= RKEY_None;
		pip_key						= isTF5800PVRt() ? RKEY_Pip : RKEY_Red;
		info_delay					= 4;

		SaveConfigurationToFile();
	}

	if (strlen(skin_file_name) == 0) {
		strcpy(skin_file_name, "SuperPip.mcf");
		SaveConfigurationToFile();
	}

	if (config_keys[3].key_value == 0) {
		config_keys[1].key_value	= RKEY_Recall;
		config_keys[2].key_value	= RKEY_Pause;
		config_keys[3].key_value	= RKEY_Record;
		config_keys[4].key_value	= RKEY_ChUp;
		config_keys[5].key_value	= RKEY_ChDown;
		config_keys[6].key_value	= RKEY_VolDown;
		config_keys[7].key_value	= RKEY_VolUp;
		config_keys[8].key_value	= RKEY_Rewind;
		config_keys[9].key_value	= RKEY_Forward;
		config_keys[10].key_value	= RKEY_2;
		config_keys[11].key_value	= RKEY_8;
		config_keys[12].key_value	= RKEY_4;
		config_keys[13].key_value	= RKEY_6;
		config_keys[14].key_value	= RKEY_1;
		config_keys[15].key_value	= RKEY_3;
		config_keys[16].key_value	= RKEY_9;
		config_keys[17].key_value	= RKEY_7;
		config_keys[18].key_value	= RKEY_5;
		SaveConfigurationToFile();
	}

	if (version_number < 1) {
		normal_keys[0].key_value	= RKEY_ChUp;
		normal_keys[1].key_value	= RKEY_ChDown;
		normal_keys[2].key_value	= RKEY_VolUp;
		normal_keys[3].key_value	= RKEY_VolDown;
		normal_keys[4].key_value	= RKEY_None;
		normal_keys[5].key_value	= RKEY_None;
		normal_keys[6].key_value	= RKEY_None;
		normal_keys[7].key_value	= RKEY_None;
		normal_keys[8].key_value	= RKEY_None;
		normal_keys[9].key_value	= RKEY_None;
		normal_keys[10].key_value	= RKEY_None;
		normal_keys[11].key_value	= RKEY_None;
		normal_keys[12].key_value	= RKEY_None;
		normal_keys[13].key_value	= RKEY_None;
		normal_keys[14].key_value	= RKEY_None;
		normal_keys[15].key_value	= RKEY_None;
		normal_keys[16].key_value	= RKEY_None;
		normal_keys[17].key_value	= RKEY_None;
		normal_keys[18].key_value	= RKEY_None;
		normal_keys[19].key_value	= RKEY_None;
		version_number = 1;
		SaveConfigurationToFile();
	}

	if (version_number < 2) {
		info_delay = 4;
		version_number = 2;
		SaveConfigurationToFile();
	}

	if (reverse_pip_key == 1) {
		reverse_pip_key = RKEY_PipSwap;
		SaveConfigurationToFile();
	}

	if (pip_key == RKEY_None) {
		pip_key	= isTF5800PVRt() ? RKEY_Pip : RKEY_Red;
		SaveConfigurationToFile();
	}

	ChangeDirSkins();
	checkForDefaultSkin();
	loadSkins();
	loadSkinElements();

	if (ChangeDirFavs()) {
		loadFavourites();
		loadFavouriteChannels();
	}
	else {
		fav_count = 0;
	}

	//TAP_Hdd_ChangeDir("..");
}

