#define SPLIT_SCREEN 0
#define SAVED_SETTINGS 1
#define TF5800 0
#define TF5000 1
#define TF5810 2

static dword version_number = 0;
char *skins[128];
char *favs[32];
int current_skin, current_fav;
int skin_count, fav_count;
word number_of_favourites;
dword favourite_channels[512];


#ifndef WIN32
// bdb code
#ifndef USE_EXTAP_KEY_EXTEND
#define RKEY_Red 		0x1003f
#define RKEY_Green		0x10024
#define RKEY_Yellow		0x10025
#define RKEY_Blue		0x10026
#define RKEY_White 		0x1003e
#define RKEY_Filelist	0x10042
#define RKEY_Options	0x10010
#define RKEY_Text		RKEY_Next
#define RKEY_Pip		0x10041
#define RKEY_PipSwap    0x10040
#define RKEY_PipList    0x10038
#define RKEY_None		0x0

#define RAWKEY_Up				0x100 
#define RAWKEY_Down				0x101 
#define RAWKEY_Right			0x102 
#define RAWKEY_Left				0x103 
#define RAWKEY_List_TVRad		0x104 
#define RAWKEY_ChUp_Subt		0x107
#define RAWKEY_VolUp_Fav		0x109
#define RAWKEY_VolDown_Exit		0x11c
#define RAWKEY_tv_radio_Uhf		0x143 
#define RAWKEY_ChDown_Teletext	0x147 
#endif
#endif

#ifdef WIN32
#define RKEY_Red 		0x1003f
#define RKEY_Green		0x10024
#define RKEY_Yellow		0x10025
#define RKEY_Blue		0x10026
#define RKEY_White 		0x1003e
#define RKEY_Filelist	0x10042
#define RKEY_Options	0x10010
#define RKEY_Text		RKEY_Next
#define RKEY_Pip		0x10041
#define RKEY_PipSwap    0x10040
#define RKEY_PipList    0x10038
#define RKEY_None		0x0

#define RAWKEY_Up				0x100 
#define RAWKEY_Down				0x101 
#define RAWKEY_Right			0x102 
#define RAWKEY_Left				0x103 
#define RAWKEY_List_TVRad		0x104 
#define RAWKEY_ChUp_Subt		0x107
#define RAWKEY_VolUp_Fav		0x109
#define RAWKEY_VolDown_Exit		0x11c
#define RAWKEY_tv_radio_Uhf		0x143 
#define RAWKEY_ChDown_Teletext	0x147 
#endif

typedef struct {
	dword key_value;
    char key_name[20];
} _keys;

static _keys keys[] = {
	{RKEY_None, "None"},
	{RKEY_Ok, "OK"},
	{RKEY_Filelist, "Archive (PlayList)"},
	{RKEY_Recall, "Recall"},
	{RKEY_TvSat, "TV/Sat"},
	{RKEY_Slow, "Slow motion"},
	{RKEY_Mute, "Mute"},
	{RKEY_Text, "Teletext (Next)"},
	{RKEY_Options, "Options (Sleep)"},
	{RKEY_Forward, "Play"},
	{RKEY_Pause, "Pause"},
	{RKEY_Rewind, "Rewind"},
	{RKEY_Forward, "Forward"},
	{RKEY_Record, "Record"},
	{RKEY_Red, "Red"},
	{RKEY_Green, "Green"},
	{RKEY_Yellow, "Yellow"},
	{RKEY_Blue, "Blue"},
	{RKEY_Pip, "PiP (Prev)"},
	{RKEY_PipSwap, "PiP Swap"},
	{RKEY_ChUp, "Up (Ch Up)"},
	{RKEY_ChDown, "Down (Ch Down)"},
	{RKEY_VolUp, "Right (Vol Up)"},
	{RKEY_VolDown, "Left (Vol Down)"},
	{RKEY_0, "0"},
	{RKEY_1, "1"},
	{RKEY_2, "2"},
	{RKEY_3, "3"},
	{RKEY_4, "4"},
	{RKEY_5, "5"},
	{RKEY_6, "6"},
	{RKEY_7, "7"},
	{RKEY_8, "8"},
	{RKEY_9, "9"},
};

#define KEY_COUNT  (sizeof(keys) / sizeof(_keys))

typedef struct {
	dword key_index;
    char key_description[30];
} _current_keys;

static _current_keys current_config_keys[] = {
	{0, "Config mode"},
	{0, "Snap to default"},
	{0, "Swap window positions"},
	{0, "Save settings"},
	{0, "Move main window up"},
	{0, "Move main window down"},
	{0, "Move main window left"},
	{0, "Move main window right"},
	{0, "Shrink main window"},
	{0, "Enlarge main window"},
	{0, "Move sub window up"},
	{0, "Move sub window down"},
	{0, "Move sub window left"},
	{0, "Move sub window right"},
	{0, "Shrink sub window"},
	{0, "Enlarge sub window"},
	{0, "Change sub channel up"},
	{0, "Change sub channel down"},
	{0, "Show sub fullscreen"},
};

#define CURRENT_CONFIG_KEY_COUNT  (sizeof(current_config_keys) / sizeof(_current_keys))

static _current_keys current_normal_keys[] = {
	{0, "Change main channel up"},
	{0, "Change main channel down"},
	{0, "Change sub channel up"},
	{0, "Change sub channel down"},
	{0, "Snap to default"},
	{0, "Swap window positions"},
	{0, "Save settings"},
	{0, "Move main window up"},
	{0, "Move main window down"},
	{0, "Move main window left"},
	{0, "Move main window right"},
	{0, "Shrink main window"},
	{0, "Enlarge main window"},
	{0, "Move sub window up"},
	{0, "Move sub window down"},
	{0, "Move sub window left"},
	{0, "Move sub window right"},
	{0, "Shrink sub window"},
	{0, "Enlarge sub window"},
	{0, "Show sub fullscreen"},
};

#define CURRENT_NORMAL_KEY_COUNT  (sizeof(current_normal_keys) / sizeof(_current_keys))

typedef struct {
	dword key_value;
} _config_keys;

_config_keys config_keys[CURRENT_CONFIG_KEY_COUNT];
_config_keys normal_keys[CURRENT_NORMAL_KEY_COUNT];

dword startup_main_x, startup_main_y, startup_main_w, startup_main_h;
dword startup_sub_x, startup_sub_y, startup_sub_w, startup_sub_h;
dword masterpiece_mode;
dword recall_snap;
char skin_file_name[100];
dword display_icons;
char fav_file_name[100];
dword firmware_hacks_enabled;
dword topfield_model;
dword reverse_pip_key;
dword pip_key;
dword info_delay;

void ChangeDirSkins();
void ChangeDirSettings();
void LoadConfiguration(void);
void loadFavouriteChannels();
void SaveConfigurationToFile(void);

//static dword activation_options[] = {RKEY_None, RKEY_Pip, RKEY_PipSwap, RKEY_Ok, RKEY_Filelist, RKEY_Recall, RKEY_TvSat, RKEY_Slow, RKEY_Mute, RKEY_TvRadio, RKEY_Text, RKEY_Options, RKEY_0, RKEY_1, RKEY_2, RKEY_3, RKEY_4, RKEY_5, RKEY_6, RKEY_7, RKEY_8, RKEY_9};
