/*
some hacks to super pip

requires exTap v0.10

1) hook the firmware channel_scale() function, to allow overiding of firmware resizing pips
2) hook the firmware set_wss() function, to allow overiding of wss
3) exTap function to get the main/sub aspect ratio / afd

could then set the correct aspect ratio of pip
could always force tv mode to 16:9 when displaying side by side pips even if pips are 4:3
etc

to set the wss:
dword fw_set_wss = 0x80050a00;                //12.88
ret = exTAP_CallFirmware((void *)fw_set_wss, a0, a1, 0,0,0,0,0,0,0,0,0);
where:
a0 = afd
a1 = WSS 1=on/0=off
(see later comments)
*/

#include <tap.h>
#include "exTap.h"
#include "exTras.h"

//----------------------------------------------------------------------------
int scale_enabled = 0;
int scale_hook_id = -2;

int wss_enabled = 0;
int wss_hook_id = -2;

int aspect_enabled = 1;
//----------------------------------------------------------------------------

int open_exTras(void)
{
	int ret;
	word i;

	if (debug) TAP_Print("Open extras\r\n");

    //determine support for different firmwares
    /*ret = exTAP_Init();
    if (ret) {
        if (debug) TAP_Print("Unsupported platform - %d:%04x\n", fw_sysid, _appl_version);
        return -1;
    }*/

    //exTAP_Key_Extend2(1);   //exTap alternative to RE
    apply_scale_hook();
    //apply_wss_hook();
    return 0;
}

void close_exTras(void)
{
	if (debug) TAP_Print("Open extras\r\n");

    remove_scale_hook();
    //remove_wss_hook();
    //TAP_Exit();
    //if (debug) TAP_Print("Exit tap\n");
}

//-----------------------------------------------------------------------------
//
//hook the channel_scale() function
//

//channel_scale(chType, x, y, w, h, mode);

type_hook scale_hook_patch[] = {
// sysid, firmware, enable, address,    length, original_data
    {456, 0x1225,   1,      0x80104e48, 8,      {0x27, 0xbd, 0xff, 0xd0,  0xaf, 0xbe, 0x00, 0x2c, }, },  //channel_scale
    {456, 0x1288,   1,      0x801050e8, 8,      {0x27, 0xbd, 0xff, 0xd0,  0xaf, 0xbe, 0x00, 0x2c, }, },  //channel_scale
    {456, 0x1326,   1,      0x8010695c, 8,      {0x27, 0xbd, 0xff, 0xd0,  0xaf, 0xbe, 0x00, 0x2c, }, },  //channel_scale
};

int apply_scale_hook(void)
{
    scale_hook_id = exTAP_ApplyHook(&scale_hook_patch[0]);
    if (scale_hook_id < 0) {
        scale_enabled = 0;
        if (debug) TAP_Print("ERROR: apply_scale_hook(), firmware version %04x not supported\n", _appl_version);
        return -1;
    }
    scale_enabled = 1;
    return 0;
}

int remove_scale_hook(void)
{
    int ret;

    if (scale_hook_id >=0) {
        ret = exTAP_RemoveHook(scale_hook_id);
        if (ret == 0) scale_hook_id = -1;
    }
    scale_enabled = 0;
    return 0;
}

dword scale_hook(dword param1, dword param2)
{
    type_hook_registers *reg;
    dword state, subState;
    int chType;
    int x,y,w,h;
    int mode;

    //if (debug) TAP_Print("EVT_HOOK_TEST, param1=%x, param2=%x\n", param1, param2);
    reg = (type_hook_registers *)param2;
    //if (debug) TAP_Print("channel_scale(%x, x=%d, y=%d, w=%d, h=%d, %x)", reg->a0, reg->a1, reg->a2, reg->a3, *(dword *)(0xa0+reg->sp), *(dword *)(0xa4+reg->sp));
    chType = reg->a0;
    x = reg->a1;
    y = reg->a2;
    w = reg->a3;
    h = *(dword *)(0xa0+reg->sp);
    mode = *(dword *)(0xa4+reg->sp);

    //intercept channel_scale()
    //if setting to full screen, put back to tap mode
    //but not entering epg, since the sub window will overlap where the main one has gone
    //tricky to tell if in epg ...

    TAP_GetState(&state, &subState);
    //if (debug) TAP_Print(", state=%x, subState=%x\n", state, subState);

    if (active) {
        if ((chType == CHANNEL_Main) && (x==0) && (y==0) && (w=720) && (h==576)) {
            reg->a1 = main_x;
            reg->a2 = main_y;
            reg->a3 = main_w;
            *(dword *)(0xa0+reg->sp) = main_h;

        	//may need to restart sub channel
            if (!TAP_Channel_IsStarted(CHANNEL_Sub)) {
                //if (debug) TAP_Print("restarting sub channel %d", sub_channel_number);
                TAP_Channel_Start(CHANNEL_Sub, SVC_TYPE_Tv, sub_channel_number);
            }
        	TAP_Channel_Scale(CHANNEL_Sub, sub_x, sub_y, sub_w, sub_h, TRUE);
            return param1;
        }
        //if just entered epg, make sure we've not restarted the sub channel
        if ((chType == CHANNEL_Main) && (x==400) && (y==70) && (w=260) && (h==200)) {
            if ((state == STATE_Epg) && (subState == SUBSTATE_Epg)) {
                //kill the sub channel
                TAP_Channel_Stop(CHANNEL_Sub);
            }
        }
    }

	//if (debug) TAP_Print("Exit scale_hook\r\n");
    return param1;
}

//-----------------------------------------------------------------------------
//
//hook the wss() function
//

//set_wss(aft, wss_enable);

type_hook wss_hook_patch[] = {
// sysid, firmware, enable, address,    length, original_data
    {456, 0x1225,   1,      0x800509DC, 8,      {0x27, 0xbd, 0xff, 0xe0,  0xaf, 0xb5, 0x00, 0x14, }, },  //set_wss()
    {456, 0x1288,   1,      0x80050A00, 8,      {0x27, 0xbd, 0xff, 0xe0,  0xaf, 0xb5, 0x00, 0x14, }, },  //set_wss()
    {456, 0x1326,   1,      0x8005226C, 8,      {0x27, 0xbd, 0xff, 0xe0,  0xaf, 0xb5, 0x00, 0x14, }, },  //set_wss()
};

int apply_wss_hook(void)
{
    wss_hook_id = exTAP_ApplyHook(&wss_hook_patch[0]);
    if (wss_hook_id < 0) {
        wss_enabled = 0;
        if (debug) TAP_Print("ERROR: apply_wss_hook(), firmware version %04x not supported\n", _appl_version);
        return -1;
    }
    wss_enabled = 1;
    return 0;
}

int remove_wss_hook(void)
{
    int ret;

    if (wss_hook_id >=0) {
        ret = exTAP_RemoveHook(wss_hook_id);
        if (ret == 0) wss_hook_id = -1;
    }
    wss_enabled = 0;
    return 0;
}

//
//a0 = afd (see EN 300294 for details)
//a1 = WSS 1=on/0=off
//    a0 = 0x0400; a1=1;          0001_00            4:3  full_format
//    a0 = 0x3400; a1=1;          1101_00            16:9 letterbox    centre
//    a0 = 0x3800; a1=1;          1110_00            16:9 full_format(anamorphic)
//    a0 = 0x1c00; a1=1;          0111_00            14:9 full_format  centre          //4:3 picture with irrelevent to scale to 16:9 on w/s
//    a0 = 0x2000; a1=1;          1000_00            14:9 letterbox    centre
//    a0 = 0x1000; a1=1;          0100_00            14:9 letterbox    top
//    a0 = 0x0800; a1=1;          0010_00            16:9 letterbox    top
//    a0 = 0x2c00; a1=1;          1011_00           >16:9 letterbox    centre
//
dword wss_hook(dword param1, dword param2)
{
    type_hook_registers *reg;
    int a0, a1;

    //if (debug) TAP_Print("EVT_HOOK_WSS, param1=%x, param2=%x\n", param1, param2);
    reg = (type_hook_registers *)param2;
    //if (debug) TAP_Print("wss(a0=%x, a1=%x)", reg->a0, reg->a1);
    a0 = reg->a0;
    a1 = reg->a1;

    //intercept wss()
    //change reg->a0 if you want to overide the setting, else just leave it alone
    /*switch(a0) {
        case 0x0400: if (debug) TAP_Print("  4:3  full_format            \n");  break;
        case 0x3400: if (debug) TAP_Print("  16:9 letterbox    centre    \n");  break;
        case 0x3800: if (debug) TAP_Print("  16:9 full_format(anamorphic)\n");  break;
        case 0x1c00: if (debug) TAP_Print("  14:9 full_format  centre    \n");  break;
        case 0x2000: if (debug) TAP_Print("  14:9 letterbox    centre    \n");  break;
        case 0x1000: if (debug) TAP_Print("  14:9 letterbox    top       \n");  break;
        case 0x0800: if (debug) TAP_Print("  16:9 letterbox    top       \n");  break;
        case 0x2c00: if (debug) TAP_Print("  16:9 letterbox    centre    \n");  break;
    }*/

	//if (debug) TAP_Print("Exit wss_hook\r\n");
    return param1;
}

//----------------------------------------------------------------------------
void display_aspect_ratio()
{
    int j;
    int main_sub;

    for (j=0; j<2; j++) {
        main_sub = (j==0) ? CHANNEL_Main : CHANNEL_Sub;

        if (debug) TAP_Print("%s Channel\n", (main_sub == CHANNEL_Sub) ? "Sub" : "Main");
        if (debug) TAP_Print("  horizontal_size    = %d\n", fw_aspect[main_sub].horizontal_size);
        if (debug) TAP_Print("  vertical_size      = %d\n", fw_aspect[main_sub].vertical_size);
        if (debug) TAP_Print("  aspect ratio       = ");
        if      (fw_aspect[main_sub].ratio==2) if (debug) TAP_Print("4:3\n");
        else if (fw_aspect[main_sub].ratio==3) if (debug) TAP_Print("16:9\n");
        else if (fw_aspect[main_sub].ratio==4) if (debug) TAP_Print("2.21:1\n");
        else                                if (debug) TAP_Print("???\n");

        if (debug) TAP_Print("  afd                = %x\n", fw_aspect[main_sub].afd);
        if (fw_aspect[main_sub].ratio == 2) {
            if (debug) TAP_Print("                       ");
            switch(fw_aspect[main_sub].afd) {
                case 0x8: if (debug) TAP_Print("4:3 full frame image                          \n"); break;
                case 0x9: if (debug) TAP_Print("4:3 full frame image                          \n"); break;
                case 0xa: if (debug) TAP_Print("16:9 letterbox image                          \n"); break;
                case 0xb: if (debug) TAP_Print("14:9 letterbox image                          \n"); break;
                case 0xd: if (debug) TAP_Print("4:3 full frame image, alternative 14:9 center \n"); break;
                case 0xe: if (debug) TAP_Print("16:9 letterbox image, alternative 14:9 center \n"); break;
                case 0xf: if (debug) TAP_Print("16:9 letterbox image, alternative 4:3 center  \n"); break;
                default : if (debug) TAP_Print("Reserved                                      \n"); break;
            }
        }
        else if (fw_aspect[main_sub].ratio == 3) {
            if (debug) TAP_Print("                       ");
            switch(fw_aspect[main_sub].afd) {
                case 0x8: if (debug) TAP_Print("16:9 full frame image                         \n"); break;
                case 0x9: if (debug) TAP_Print("4:3 pillarbox image                           \n"); break;
                case 0xa: if (debug) TAP_Print("16:9 full frame image                         \n"); break;
                case 0xb: if (debug) TAP_Print("14:9 pillarbox image                          \n"); break;
                case 0xd: if (debug) TAP_Print("4:3 pillarbox image, alternative 14:9 center  \n"); break;
                case 0xe: if (debug) TAP_Print("16:9 full frame image, alternative 14:9 center\n"); break;
                case 0xf: if (debug) TAP_Print("16:9 full frame image, alternative 4:3 center \n"); break;
                default : if (debug) TAP_Print("Reserved                                      \n"); break;
            }
        }
    }
}

//----------------------------------------------------------------------------
