static char *skin_buffer;
static int skin_pointer;
static word element_index;
static dword byte_count;

#define DEFAULT_SKIN_NAME "SuperPip.mcf"

typedef struct {
    char name[40];
    char description[256];
} element_names;


// table of element names and their corresponding description
static element_names skin_element_names[] = {
    {"Frame",						"Main frame (outside edge)"},
	{"TextForeground",				"Main text"},
	{"MainInfoBox",					"Main info box background"},
	{"SubInfoBox",					"Sub info box background"},
	{"ConfigModeBox",				"Config mode box background"},
	{"SavedSettingsBox",			"Saved settings box background"},
};

#define SKIN_ELEMENT_COUNT  (sizeof(skin_element_names) / sizeof(element_names))

word frame_colour;
word text_colour;
word main_info_colour;
word sub_info_colour;
word config_mode_colour;
word saved_settings_colour;

bool readSkinFile();
void loadSkinElements();
void loadSkinElement();
void translateSkinElement(char *element_string);
void extractRGB(char *element_name, char *rgb_value);
word convertRGB(char *value);
void checkForDefaultSkin();



